/**
 * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 * 
 */

'use strict';function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self, call) {if (!self) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call && (typeof call === "object" || typeof call === "function") ? call : self;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}

var chalk = require('chalk');
var BULLET = chalk.bold('\u25CF');
var DEPRECATION = BULLET + ' Deprecation Warning';
var ERROR = BULLET + ' Validation Error';
var WARNING = BULLET + ' Validation Warning';

var format = function format(value) {return (
    typeof value === 'function' ?
    value.toString() :
    require('pretty-format')(value, { min: true }));};var

ValidationError = function (_Error) {_inherits(ValidationError, _Error);



  function ValidationError(name, message, comment) {_classCallCheck(this, ValidationError);var _this = _possibleConstructorReturn(this, (ValidationError.__proto__ || Object.getPrototypeOf(ValidationError)).call(this));

    comment = comment ? '\n\n' + comment : '\n';
    _this.name = '';
    _this.message = chalk.red(chalk.bold(name) + ':\n\n' + message + comment);
    Error.captureStackTrace(_this, function () {});return _this;
  }return ValidationError;}(Error);


var logValidationWarning = function logValidationWarning(
name,
message,
comment)
{
  comment = comment ? '\n\n' + comment : '\n';
  console.warn(chalk.yellow(chalk.bold(name) + ':\n\n' + message + comment));
};

var createDidYouMeanMessage = function createDidYouMeanMessage(
unrecognized,
allowedOptions)
{
  var leven = require('leven');
  var suggestion = allowedOptions.find(function (option) {
    var steps = leven(option, unrecognized);
    return steps < 3;
  });

  return suggestion ? 'Did you mean ' + chalk.bold(format(suggestion)) + '?' : '';
};

module.exports = {
  DEPRECATION: DEPRECATION,
  ERROR: ERROR,
  ValidationError: ValidationError,
  WARNING: WARNING,
  createDidYouMeanMessage: createDidYouMeanMessage,
  format: format,
  logValidationWarning: logValidationWarning };